import { ConfigType } from '@nestjs/config';
import { Global, Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';

import config from 'src/config';

@Global()
@Module({
  imports: [
    TypeOrmModule.forRootAsync({
      name: 'apec',
      inject: [config.KEY],
      useFactory: (configService: ConfigType<typeof config>) => {
        const { user, password, host, dbApec } = configService.mssql;
        return {
          name: 'apec',
          type: 'mssql',
          host,
          database: dbApec,
          username: user,
          password,
          synchronize: false,
          autoLoadEntities: true,
          options: {
            // http://tediousjs.github.io/tedious/api-connection.html
            encrypt: true, // Set to true if you're on Windows Azure. (default: true)
            trustServerCertificate: true, // change to true for local dev / self-signed certs
            cryptoCredentialsDetails: {
              /**
               * Node.js 17+ does not support certificates that use SHA1.
               * The default certificate generated by SQL Server uses SHA1.
               * That's why the connection is closed by SQL Server after
               * receiving the list of supported certificate algorithms from
               * SQL Server. Switch the certificate on SQL Server to one that
               * does not use SHA1, or switch to an unencrypted connection
               * (absolutely not recommended), because using a SHA1 certificate
               * is worse than using no encryption at all, as it adds no
               * security but makes you think your connection is encrypted.
               * https://github.com/tediousjs/tedious/issues/1449#issuecomment-1287801436
               *
               * https://github.com/tediousjs/node-mssql/issues/1403
               * https://github.com/tediousjs/tedious/issues/1449#issuecomment-1287801436
               * https://github.com/tediousjs/tedious/issues/1449#issuecomment-1287854211
               */
              ciphers: 'DEFAULT@SECLEVEL=0', // https://nodejs.org/docs/latest-v18.x/api/tls.html#tlscreatesecurecontextoptions
            },
          },
        };
      },
    }),
    TypeOrmModule.forRootAsync({
      name: 'pg',
      inject: [config.KEY],
      useFactory: (configService: ConfigType<typeof config>) => {
        const { user, host, dbName, password, port } = configService.postgres;
        return {
          name: 'pg',
          type: 'postgres',
          host,
          port,
          username: user,
          password,
          database: dbName,
          // entities: ['src/**/*.entity.ts'],
          synchronize: false,
          autoLoadEntities: true,
        };
      },
    }),
  ],
  providers: [],
  exports: [TypeOrmModule],
})
export class DatabaseModule {}
